'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-15d2a36c.js');

const K2btSignaturePad = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.changeEvent = index.createEvent(this, "change", 7);
    this.width = 300;
    this.height = 200;
    this.backgroundimageurl = '';
    this.backgroundcolor = '#FFFFFF';
    this.showclearbutton = true;
    this.clearbuttoncaption = 'Clear';
    this.canvas = null;
    this.ctx = null;
    this.isWriting = false;
    this.setValueDebouncer = null;
  }
  render() {
    var _a, _b;
    var style = {
      backgroundImage: ((_a = this.backgroundimageurl) !== null && _a !== void 0 ? _a : '') !== '' ? 'url(' + this.backgroundimageurl + ')' : null,
      backgroundColor: ((_b = this.backgroundcolor) !== null && _b !== void 0 ? _b : '') !== '' ? this.backgroundcolor : null,
    };
    console.log(style);
    return (index.h(index.Host, null, index.h("div", { class: "K2BT_SignaturePadContainer", style: style }, index.h("canvas", { height: this.height, width: this.width, class: "K2BT_SignaturePad", ref: canvas => {
        this.canvas = canvas;
        this.ctx = canvas.getContext('2d');
      } })), this.showclearbutton ? (index.h("button", { class: "K2BT_SignaturePadClearButton", onClick: this.clearCanvas.bind(this) }, this.clearbuttoncaption)) : ('')));
  }
  componentDidRender() {
    this.canvas.addEventListener('pointerdown', this.handlePointerDown.bind(this), { passive: true });
    document.addEventListener('pointerup', this.handlePointerUp.bind(this), { passive: true });
    this.canvas.addEventListener('pointermove', this.handlePointerMove.bind(this), { passive: true });
  }
  clearCanvas() {
    this.ctx.clearRect(0, 0, this.canvas.width, this.canvas.height);
  }
  handlePointerDown(event) {
    this.isWriting = true;
    this.ctx.beginPath();
    const [positionX, positionY] = this.getCursorPosition(event);
    this.ctx.moveTo(positionX, positionY);
  }
  handlePointerUp() {
    var wasWriting = this.isWriting;
    this.isWriting = false;
    if (wasWriting) {
      if (this.setValueDebouncer !== null) {
        clearTimeout(this.setValueDebouncer);
      }
      this.setValueDebouncer = setTimeout((() => {
        this.setValueDebouncer = null;
        this.changeEvent.emit(this.canvas.toDataURL());
      }).bind(this), 200);
    }
  }
  handlePointerMove(event) {
    if (!this.isWriting)
      return;
    const [positionX, positionY] = this.getCursorPosition(event);
    this.ctx.lineTo(positionX, positionY);
    this.ctx.stroke();
  }
  getCursorPosition(event) {
    var positionX = event.clientX - event.target.getBoundingClientRect().x;
    var positionY = event.clientY - event.target.getBoundingClientRect().y;
    return [positionX, positionY];
  }
};

exports.k2bt_signature_pad = K2btSignaturePad;
